var freeslotsOverlay = {
  prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),
  
  checkFirstInstall: function() {
    if (!freeslotsOverlay.prefs.getBoolPref("extensions.freeslots.installed")) {
      freeslotsOverlay.prefs.setBoolPref("extensions.freeslots.installed", true);
      var newTab = getBrowser().addTab("chrome://freeslots/content/firstTimeConfig.xul");
      getBrowser().selectedTab = newTab;
    }
  },
  
  addToolbarIcon: function() {
    freeslotsOverlay.appendButtonInToolbar("freeslots-toolbar-button", "nav-bar");
  },
  
  appendButtonInToolbar:function(buttonId, toolbarId) {
      var toolbar = document.getElementById(toolbarId);
      var button = document.getElementById(buttonId);
      if(button) {
          var parentBar = button.parentNode;              
          if(parentBar && parentBar != toolbar) {
              var newset = freeslotsOverlay.removeButtonFromToolbarCurrentSet(parentBar,buttonId);              
          }
          toolbar.appendChild(button);
      }else{          
        if ("insertItem" in toolbar) {
          toolbar.insertItem(buttonId);
        }
      }
  
      freeslotsOverlay.appendButtonInToolbarCurrentSet(toolbar,buttonId);
      try {
        BrowserToolboxCustomizeDone(true);
      } catch (e) {}
  },
  
  appendButtonInToolbarCurrentSet:function(toolbar, buttonId) {
      var oldset = toolbar.getAttribute("currentset");
      var newset = "";
      if(oldset && oldset!="") {
          newset = oldset + ",";
      }        
      newset += buttonId;        
      toolbar.setAttribute("currentset", newset);
      document.persist(toolbar.id,"currentset");
      return newset;
  },
  
  
  removeButtonFromToolbarCurrentSet:function(toolbar, buttonId) {
      var oldset = toolbar.getAttribute("currentset");
      if(!oldset || oldset=="" || oldset.indexOf(buttonId) == -1) return oldset;
      var reg = new RegExp(buttonId+",?", "gi");        
      var newset = oldset.replace(reg,"");
      if (newset.charAt(newset.length-1) == ",") {
         newset = newset.substring(0, newset.length - 1);
      }
  
      toolbar.setAttribute("currentset", newset);
      document.persist(toolbar.id,"currentset");
      return newset;
  },
  
  openLink: function(url, event) {
    event.stopPropagation();
    var newTab = freeslotsOverlay.prefs.getBoolPref("extensions.freeslots.newtab");
    if (url.indexOf('%CURRENT_URL%') > -1) {
      url = url.replace('%CURRENT_URL%', encodeURIComponent(getBrowser().currentURI.spec));
    }
    if (url.indexOf('%TEXT_PROMPT%') > -1) {
      var bundle = document.getElementById("freeslots-strings");
      var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                               .getService(Components.interfaces.nsIPromptService);
      var inputText = { value: '' };
      var checkValue = { value: false };
      if (promptService.prompt(window, bundle.getString("prompt.title"), bundle.getString("prompt.message"), inputText, null, checkValue)) {
        url = url.replace('%TEXT_PROMPT%', encodeURIComponent(inputText.value));
      } else {
        return;
      }
    }
    if (newTab) {
      var newTab = getBrowser().addTab(url);
      getBrowser().selectedTab = newTab;
    } else if (typeof window.openLinkIn == 'function') {
      openLinkIn(url, 'current', {});
    } else {
      getBrowser().loadURI(url, null, null, false);
    }
  }
};

window.addEventListener("load", function () { window.setTimeout(function() { freeslotsOverlay.checkFirstInstall();}, 900); }, false);
